float offsetX;
float offsetY;

float marginX = 200;
float marginY = 0;

float speed = 10;
float animationHeight = 700;

int numberOfFrames = 3;

//PImage frame0;
//PImage frame1;

ArrayList<Frame> frames;

//Boolean isVisibleFrame0;
//Boolean isVisibleFrame1;

//float frame0VisibleHeight;
//float frame1VisibleHeight;

void setup()
{
  size(1000,500);
  
  offsetX = 0;
  offsetY = 0;
  fill(255);
  
  //frame0 = loadImage("cat0.png");
  //frame1 = loadImage("cat1.png");
  //isVisibleFrame0 = false;
  //isVisibleFrame1 = false;
  //frame0VisibleHeight = 400;
  //frame1VisibleHeight = 600;
  
  frames = new ArrayList<Frame>();
  for(int i=0; i<numberOfFrames; ++i)
  {
    frames.add(new Frame( loadImage("cat"+i+".png"), i*marginX));
  }
}

void draw()
{
  background(0);
  pushMatrix();
  offsetY += 1 * speed;
  if(offsetY > animationHeight)
  {
    offsetY = 0;
  }
  
  translate(100, offsetY);
  
  for(int i=0; i<frames.size(); ++i)
  {
    frames.get(i).updateVisibility(offsetY);
    if(frames.get(i).getVisibility())
    {
      pushMatrix();
      translate(i * marginX, marginY -i * 150);
      frames.get(i).drawImage();
      popMatrix();
    }
  }
  
  popMatrix();
  
  saveFrame("frame###.png");
}